float4 dims;
float4 diffusecol = float4(1,1,1,1);

texture g_txSrc;

sampler2D g_sSrc = sampler_state {
    Texture = <g_txSrc>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

struct VSOUT
{
	float4 vpos : POSITION;
	float2 tex0 : TEXCOORD0;
};


VSOUT VS(in float4 pos : POSITION,
			in float2 tex : TEXCOORD0)
{
	VSOUT o;
	o.vpos.xy = pos.xy * dims.xy + dims.zw;
	o.vpos.zw = pos.zw;
	o.tex0 = tex;
	return o;
}

float4 PS(VSOUT i) : COLOR
{
	float4 c = tex2D(g_sSrc, i.tex0);
	c.w = c.x;
	return c * diffusecol;
}

technique tech0 {
	pass p0 {
		VertexShader = compile vs_1_1 VS();
		PixelShader = compile ps_1_1 PS();
	}
}

