// post process: takes the average of every 8x8 square
texture g_txRealLum < int postrt = 4; >;
texture g_txCurLum < int postrt = 5; >;

sampler2D g_sRealLum = sampler_state {
    Texture = <g_txRealLum>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

sampler2D g_sCurLum = sampler_state {
    Texture = <g_txCurLum>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

float4 AdaptedLum(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
    float fAdaptedLum = tex2D(g_sCurLum, float2(0.5f, 0.5f));
    float fCurrentLum = tex2D(g_sRealLum, float2(0.5f, 0.5f));

    return fAdaptedLum + 0.05*(fCurrentLum - fAdaptedLum);
}

technique tech0 < int postrt = 5;
				int width = 1;
				int height = 1;
				string usepost0 = "PP_SumLumFinal";
				int hdr = 1;
				> {
	pass p0 {
		PixelShader = compile ps_2_0 AdaptedLum();
	}
}
