// beginning of luminance computation on a 64x64 texture
texture g_txSrc < int postrt = 0; >;

sampler2D g_samSrc = sampler_state {
    Texture = <g_txSrc>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

static const float3 LUMINANCE_VECTOR  = float3(0.2125f, 0.7154f, 0.0721f);
static const int SAMPLES = 9;

float2 PixelKernel[SAMPLES] = {
	-0.3333, 0.3333, 	0.0, 0.3333, 	0.3333, 0.3333,
	-0.3333, 0.0000, 	0.0, 0.0000, 	0.3333, 0.0000,
	-0.3333, -0.3333, 	0.0, -0.3333,	0.3333, -0.3333
	};
	

uniform float ftemp = 0;

float2 TexelKernel[SAMPLES] < string ConvertPixelsToTexels = "PixelKernel"; >;

float4 BeginLum(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
    float flog = 0;

	for( int i=0; i < SAMPLES; i++ ) {
		flog += log(16*dot(tex2D( g_samSrc, vScreenPosition + TexelKernel[i]).xyz, LUMINANCE_VECTOR)+1);
	}

	return flog * 0.1111f;
}

technique tech0 <	int postrt = 1;
					int width = 64;
					int height = 64;
					string usepost0 = "PP_Scale_x4";
					int hdr = 1;
				> {
	pass p0 {
		PixelShader = compile ps_2_0 BeginLum();
	}
}
