texture g_txSrcColor < int postrt = 7; >;

sampler2D g_sSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};


static const int g_cKernelSize = 9;

float2 PixelKernel[g_cKernelSize] =
{
    { 0, -4 },
    { 0, -3 },
    { 0, -2 },
    { 0, -1 },
    { 0,  0 },
    { 0,  1 },
    { 0,  2 },
    { 0,  3 },
    { 0,  4 },
};

float2 TexelKernel[g_cKernelSize] < string ConvertPixelsToTexels = "PixelKernel"; >;

static const float BlurWeights[g_cKernelSize] = 
{
    0.027601,
	0.066213,
	0.123701,
	0.179952,
	0.205065,
	0.179952,
	0.123701,
	0.066213,
	0.027601,
};

float c_BloomScale = 1.0f;

float4 BloomV( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float4 Color = 0;

    for (int i = 0; i < g_cKernelSize; i++)
    {    
        Color += tex2D( g_sSrcColor, Tex + TexelKernel[i].xy ) * BlurWeights[i];
    }

    return Color * c_BloomScale;
}

technique tech0 <	int postrt = 7;
					float scalex = 0.25f;
					float scaley = 0.25f;
					string usepost0 = "PP_BloomH";	
				> {
    pass p0 {
        PixelShader = compile ps_2_0 BloomV();
    }
}
