texture g_txSrcColor < int postrt = 8; >;

sampler2D g_sSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};


static const int g_cKernelSize = 4;

float2 PixelKernel[g_cKernelSize] = {
	0,0,
	1,0,
	0,1,
	1,1 };
	
//       -1,1,	0,1,	1,1,
//       -1,0,	0,0,	1,0,
//       -1,-1,	0,-1,	1,-1 };

float2 TexelKernel[g_cKernelSize]
<
    string ConvertPixelsToTexels = "PixelKernel";
>;

static const float BlurWeights[g_cKernelSize] =
{
	0.25, 0.25, 0.25, 0.25
//    0.07514,	0.1238,		0.07514,
//    0.1238, 	0.2042,		0.1238,
//    0.07514,	0.1238,		0.07514,
};

float4 BloomH( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float4 Color = 0;

    for (int i = 0; i < g_cKernelSize; i++)
    {
        Color += tex2D( g_sSrcColor, Tex + TexelKernel[i].xy ) * BlurWeights[i];
    }

    return Color;
}

technique tech0 <	int postrt = 8;
					string usepost0 = "PP_Star";
					float scalex = 0.25f;
					float scaley = 0.25f;
				> {
    pass p0 {
        PixelShader = compile ps_2_0 BloomH();
    }
}
