texture g_txSrcColor < int rt = 0; >;

sampler2D g_samSrcColor =
sampler_state
{
    Texture = <g_txSrcColor>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

float c_Luminance = 0.08f;
static const float c_fMiddleGray = 0.18f;
static const float c_fWhiteCutoff = 0.8f;

float4 BrightPassFilter( in float2 Tex : TEXCOORD0 ) : COLOR0
{
    float3 ColorOut = tex2D( g_samSrcColor, Tex );

    ColorOut *= c_fMiddleGray / ( c_Luminance + 0.001f );
    ColorOut *= ( 1.0f + ( ColorOut / ( c_fWhiteCutoff * c_fWhiteCutoff ) ) );
    ColorOut -= 5.0f;

    ColorOut = max( ColorOut, 0.0f );

    ColorOut /= ( 10.0f + ColorOut );

    return float4( ColorOut, 1.0f );
}

technique PostProcess < int postrt = 9; >
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 BrightPassFilter();
        ZEnable = false;
    }
}
