// post process effect scales the bloom texture by 4
texture g_txSrc < int rt = 1; >;

sampler2D g_samSrc = sampler_state {
    Texture = <g_txSrc>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

static const int SAMPLES = 4;

float2 PixelKernel[SAMPLES] = {
	-1, -1,
	1, -1,
	-1, 1,
	1, 1};
	
float2 TexelKernel[SAMPLES] < string OrgPixels = "PixelKernel"; >;

float4 Scale_x4(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
    float4 sample = 0.0f;

	for( int i=0; i < SAMPLES; i++ ) {
		sample += tex2D( g_samSrc, vScreenPosition + TexelKernel[i] );
	}
    
	return sample * 0.25;
}

technique tech0 <	int postrt = 0;
					float scalex = 0.25;
					float scaley = 0.25f;
				> {
	pass p0 {
		PixelShader = compile ps_2_0 Scale_x4();
	}
}
