texture g_txScene < int rt = 0; >;
texture g_txCurLum <int postrt = 5; >;
texture g_txBloom < int postrt = 7; >;
texture g_txStar < int postrt = 8; >;
texture g_txBlur < int postrt = 6; >;
texture g_txPreBloom < int postrt = 0; >;

texture g_txLum1 < int postrt = 2; >;
texture g_txLum2 < int postrt = 3; >;

sampler2D g_sScene = sampler_state {
    Texture = <g_txScene>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

sampler2D g_sCurLum = sampler_state {
    Texture = <g_txCurLum>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Point;	MagFilter = Point;	MipFilter = Point;
};

sampler2D g_sBloom = sampler_state {
    Texture = <g_txBloom>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

sampler2D g_sStar = sampler_state {
    Texture = <g_txStar>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

sampler2D g_sBlur = sampler_state {
    Texture = <g_txBlur>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

sampler2D g_sPreBloom = sampler_state {
    Texture = <g_txPreBloom>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

sampler2D g_sLum1 = sampler_state {
    Texture = <g_txLum1>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

sampler2D g_sLum2 = sampler_state {
    Texture = <g_txLum2>;
    AddressU = Clamp;	AddressV = Clamp;
    MinFilter = Linear;	MagFilter = Linear;	MipFilter = Linear;
};

int c_iRendType;

float2 PixelKernel[4] = {
       0,0,
       8,0,
       0,8,
       8,8 };

float2 TexelKernel[4] < string ConvertPixelsToTexels = "PixelKernel"; >;

float4 ScenePS(float2 vtex : TEXCOORD0) : COLOR
{
	float4 c;

	float flum = tex2D(g_sCurLum, float2(0.5,0.5)).x;

   	float fblur = (tex2D(g_sBloom, vtex+TexelKernel[0])+
   				tex2D(g_sBloom, vtex+TexelKernel[1])+
   				tex2D(g_sBloom, vtex+TexelKernel[2])+
   				tex2D(g_sBloom, vtex+TexelKernel[3]));
        c = tex2D(g_sScene, vtex) + fblur;//+4*tex2D(g_sStar, vtex);
	c.xyz *= 0.606 / flum;

	if( c_iRendType == 1 ) c /= (c + 1);
	if( c_iRendType == 2 ) c = 0.2*flum;

	if( c_iRendType == 3 ) c = tex2D(g_sLum1, vtex);
	if( c_iRendType == 4 ) c = tex2D(g_sLum2, vtex);
	//c = tex2D(g_sBloom, vtex);

	//float3 ColorOrig = tex2D( g_sSceneColor, Tex2 );
	//float3 ColorBlur = tex2D( g_samSrcColor, Tex );
	//float Blur = dot( tex2D( g_samSrcPosition, Tex ), FocalPlane );

	//oCol = float4( lerp( ColorOrig, ColorBlur, saturate(abs(Blur)) ), 1.0f );
	return c;
}

// annotations describe the post processing effects should render before the scene
technique SceneTech <
	string usepost0 = "PP_BloomV";
	string usepost1 = "PP_AdaptedLum";
	//	string usepost1 = "PP_BlurStar";
> {
	pass P0 {
		VertexShader = null;
		PixelShader = compile ps_2_0 ScenePS();
	}
}
