// post process: takes the average of every 8x8 square
texture g_txSrc < int postrt = 1; >;

sampler2D g_samSrc = sampler_state {
    Texture = <g_txSrc>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

static const int SAMPLES = 16;

float2 PixelKernel[SAMPLES] = {
	-1.5/4, -1.5/4,	-0.5/4, -1.5/4,	0.5/4, -1.5/4,	1.5/4, -1.5/4,
	-1.5/4, -0.5/4,	-0.5/4, -0.5/4,	0.5/4, -0.5/4,	1.5/4, -0.5/4,
	-1.5/4, 0.5/4,	-0.5/4, 0.5/4,	0.5/4, 0.5/4,		1.5/4, 0.5/4,
	-1.5/4, 1.5/4,	-0.5/4, 1.5/4,	0.5/4, 1.5/4,		1.5/4, 1.5/4
	};
	
float2 TexelKernel[SAMPLES] < string ConvertPixelsToTexels = "PixelKernel"; >;

float4 SumLum1_x4(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
    float sample = 0.0f;

	for( int i=0; i < SAMPLES; i++ ) {
		sample += tex2D( g_samSrc, vScreenPosition + TexelKernel[i] ).x;
	}
    
	return sample/16;
}

technique tech0 <	int postrt = 2;
					int width = 16;
					int height = 16;
					string usepost0 = "PP_BeginLum";
					int hdr = 1;
				> {
	pass p0 {
		PixelShader = compile ps_2_0 SumLum1_x4();
	}
}
