float4x4 c_WVP;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressV = Wrap;
};

// mtrl type: BkgndTexture;
struct VSINPUT {
float4 v_pos : POSITION;
float3 v_normal : NORMAL;
float2 v_tex0 : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float2 b_objtex0:TEXCOORD0;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
float3 b_objnorm = i.v_normal;
float2 b_objtex0 = i.v_tex0;


o.b_objtex0 = b_objtex0;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float2 b_objtex0 = i.b_objtex0;
o.color0 = 0;
o.color1 = 0;
o.color0.rgba = 0;

o.color0.xyzw = tex2D(c_tex, b_objtex0);
o.color0.xyz += 0.2*o.color0.w;
o.color1.w = o.color0.w+o.color0.x;
return o;
}

technique tech0
{
	pass P0
	{
AlphaBlendEnable = True;
SrcBlend = InvSrcAlpha;
DestBlend = SrcAlpha;
AlphaTestEnable = True;
ZWriteEnable = False;
AlphaRef = 250;
AlphaFunc = Less;
VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

