float4x4 c_WVP;
float4 c_SunDir;
float4x3 c_WorldMat;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_texbump;
sampler2D c_texbump = sampler_state {
Texture = <t_c_texbump>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float2 c_mexp;
texture t_c_texenv;
samplerCUBE c_texenv = sampler_state {
Texture = <t_c_texenv>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
};

float2 c_kr;
float c_bump;
// mtrl type: Env Refl Spec;
struct VSINPUT {
float4 v_pos : POSITION;
float3 v_normal : NORMAL;
float3 v_tangent : TANGENT;
float2 v_tex0 : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float3 fwtang:TEXCOORD0;
float3 fwbinorm:TEXCOORD1;
float3 fwnorm:TEXCOORD2;
float4 flightdir:TEXCOORD3;
float3 h:TEXCOORD4;
float2 b_objtex0:TEXCOORD5;
half4 b_camdir:TEXCOORD6;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
float3 b_objnorm = i.v_normal;
float3 b_objtangent = i.v_tangent;
float2 b_objtex0 = i.v_tex0;
float3 h;
float4 vals;
float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
half3 binorm = cross(b_objnorm, b_objtangent);
float4 flightdir;
float3 v;
half3 fwtang = mul(b_objtangent, (float3x3)c_WorldMat);
o.fwtang = fwtang;


half3 fwbinorm = mul(binorm, (float3x3)c_WorldMat);
o.fwbinorm = fwbinorm;


half3 fwnorm = mul(b_objnorm, (float3x3)c_WorldMat);
o.fwnorm = fwnorm;


flightdir.x = dot(c_SunDir.xyz, b_objtangent);
flightdir.y = dot(c_SunDir.xyz, binorm);
flightdir.z = dot(c_SunDir.xyz, b_objnorm);
flightdir.w = 1;
o.flightdir = flightdir;


v = normalize(b_camdir + c_SunDir);
h.x = dot(v, b_objtangent);
h.y = dot(v, binorm);
h.z = dot(v, b_objnorm);
o.h = h;

o.b_objtex0 = b_objtex0;

o.b_camdir = b_camdir;
o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float3 fwtang = i.fwtang;
float3 fwbinorm = i.fwbinorm;
float3 fwnorm = i.fwnorm;
float4 flightdir = i.flightdir;
float3 h = i.h;
float2 b_objtex0 = i.b_objtex0;
half4 b_camdir = i.b_camdir;
o.color0 = 0;
float3 fdif = 0;
o.color0.rgba = 0;
half3 fnorm = 2 * tex2D(c_texbump  , b_objtex0) - 1;
half2 vals;
half3 b_objnorm = fnorm.x * fwtang + fnorm.y * fwbinorm + fnorm.z * fwnorm;
b_objnorm = lerp(c_bump, float3(0,1,0), b_objnorm);


vals.xy = lit(dot(flightdir.xyz, fnorm), dot(fnorm, h),  c_mexp  .x).yz;
fdif += 0.5*flightdir.w * vals.x;
o.color0.xyz +=  0.15*c_mexp  .y * vals.y;
half4 b_camrefl;
b_camrefl.w = dot(b_objnorm.xyz, b_camdir.xyz);
b_camrefl.xyz = 2 * b_camrefl.w * b_objnorm.xyz - b_camdir.xyz;
float b_fres = (1-b_camrefl.w) * (1-b_camrefl.w);
b_fres = c_kr.x + c_kr.y * b_fres * b_fres;

o.color0.xyz += fdif * tex2D(c_tex, b_objtex0);
o.color0.rgba += 0.4* b_fres * texCUBE(c_texenv, b_camrefl.xyz);
o.color0.w = 0;
return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

