float4x4 c_WVP;
float3 c_CameraPos;
float3 c_CameraDir;
texture t_c_maintex;
sampler2D c_maintex = sampler_state {
Texture = <t_c_maintex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Clamp;
};

texture t_c_tnoise;
sampler2D c_tnoise = sampler_state {
Texture = <t_c_tnoise>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

// mtrl type: LvlBillboard;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_color0 : COLOR0;
half4 v_color1 : COLOR1;
half4 v_tex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float3 ftex:TEXCOORD0;
float4 b_objcolor0:COLOR;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 b_objnorm = i.v_normal;
half4 b_objcolor0 = i.v_color0;
half4 b_objcolor1 = i.v_color1;
half4 b_objtex = i.v_tex;
b_objnorm.xyz = 2 * b_objnorm.zyx - 1;
float rand = b_objcolor1.x;
float2 d = 2*b_objcolor1.zy - 1;
float3 vdirperp = b_objpos.xyz - c_CameraPos.xyz;
float size = b_objtex.x + 256*b_objtex.w;
float dist = dot(vdirperp, c_CameraDir);
vdirperp = normalize(vdirperp - b_objnorm * dot(vdirperp, b_objnorm));

b_objpos.xyz += size * d.x * cross(b_objnorm, vdirperp);

half3 ftex;
ftex.xy = b_objtex.zy;
ftex.z = 1 - clamp(0.002 * dist - 0.1, 0, 1);

o.ftex = ftex;

o.b_objcolor0 = b_objcolor0;



o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float3 ftex = i.ftex;
float4 b_objcolor0 = i.b_objcolor0;
o.color0 = 0;
o.color1 = 0;
float noise = tex2D(c_tnoise, ftex.xy).x;
o.color0.rgba = b_objcolor0 * tex2D(c_maintex, ftex.xy).xyzx;
o.color0.w *= ftex.z > 0.8 ? ftex.z+0.2*noise : 0.5+ ftex.z * noise;

o.color1.rgb = 0;


return o;
}

technique tech0
{
	pass P0
	{
CullMode = None;
AlphaTestEnable = True;
AlphaRef = 15;
AlphaFunc = GREATER;
//SrcBlend = SRCALPHA;
//DestBlend = INVSRCALPHA;

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

