float4x4 c_WVP;
float4 c_SunDir;
float4 c_SunColor;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_texbump;
sampler2D c_texbump = sampler_state {
Texture = <t_c_texbump>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_color;
// mtrl type: LvlRock;
struct VSINPUT {
float4 v_pos : POSITION;
float3 v_normal : NORMAL;
float3 v_tangent : TANGENT;
float2 v_tex0 : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float3 fsundir:TEXCOORD0;
float3 h:TEXCOORD1;
float2 b_objtex0:TEXCOORD2;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
float3 b_objnorm = i.v_normal;
float3 b_objtangent = i.v_tangent;
float2 b_objtex0 = i.v_tex0;

float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
//Send ToPS(b_objnorm, 3);
//Send ToPS(b_objtangent, 3);
float3 binorm = cross(b_objnorm, b_objtangent);
//Send ToPS(binorm, 3);
half3 fsundir;
fsundir.x =dot(b_objtangent.xyz, c_SunDir.xyz);
fsundir.y =dot(binorm.xyz, c_SunDir.xyz);
fsundir.z =dot(b_objnorm.xyz, c_SunDir.xyz);
o.fsundir = fsundir;


float3 nh = normalize(b_camdir.xyz + c_SunDir.xyz);
half3 h;
h.x =dot(b_objtangent.xyz, nh.xyz);
h.y =dot(binorm.xyz, nh.xyz);
h.z =dot(b_objnorm.xyz, nh.xyz);
o.h = h;


o.b_objtex0 = b_objtex0;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float3 fsundir = i.fsundir;
float3 h = i.h;
float2 b_objtex0 = i.b_objtex0;
o.color0 = 0;
half3 fdif = 0;
half3 spec = 0;
o.color0.rgba = 0;
half3 norm = 2 * tex2D(c_texbump  , b_objtex0 ) - 1;

half2 col = lit(dot(norm, fsundir), dot(norm, h), c_color.w).yz;

fdif += c_SunColor * col.x + 0.2;
spec += 0.4* c_SunColor * col.y;
o.color0.xyz += c_color.xyz * fdif * tex2D(c_tex, b_objtex0) + spec;
o.color0.w = 0;
return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

