float4x4 c_WVP;
float4 c_SunDir;
float4 c_SunColor;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_texbump;
sampler2D c_texbump = sampler_state {
Texture = <t_c_texbump>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
};

// mtrl type: Texture;
struct VSINPUT {
float4 v_pos : POSITION;
float3 v_normal : NORMAL;
float2 v_tex0 : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;

};

struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float3 fsun:TEXCOORD0;
float2 b_objtex0:TEXCOORD1;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
float3 b_objnorm = i.v_normal;
float2 b_objtex0 = i.v_tex0;


float fNL = max(dot(b_objnorm, c_SunDir), 0);
float3 fsun;
fsun.xyz = (fNL+0.3) * c_SunColor.xyz;
o.fsun = fsun;


b_objtex0.x *= 4;
o.b_objtex0 = b_objtex0;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float3 fsun = i.fsun;
float2 b_objtex0 = i.b_objtex0;
o.color0 = 0;
float3 fdif = 0;
o.color0.rgba = 0;

fdif.xyz += fsun;
o.color0.xyz += fdif * tex2D(c_tex, b_objtex0);
o.color0.w = 0;
return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

