float4x4 c_WVP;
float4 c_SunDir;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_spec;
float2 c_kr;
texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_trefl;
sampler2D c_trefl = sampler_state {
Texture = <t_c_trefl>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float3 c_ref;
float3 c_snow;
float3 c_ice;
// mtrl type: bkFrozen;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_tangent : TANGENT0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 fcamdir:TEXCOORD0;
float4 fsundir:TEXCOORD1;
float2 v_blendtex:TEXCOORD2;
float4 fproj:TEXCOORD3;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
half4 b_objtangent = i.v_tangent.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;

float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
half3 binorm = cross(b_objnorm.xyz, b_objtangent.xyz);

float4 fcamdir;
fcamdir.x = dot(b_camdir.xyz, b_objtangent);
fcamdir.y = dot(b_camdir.xyz, binorm);
fcamdir.z = dot(b_camdir.xyz, b_objnorm);
fcamdir.w = b_objnorm.w;
o.fcamdir = fcamdir;


half4 fsundir;
fsundir.x = dot(c_SunDir.xyz, b_objtangent);
fsundir.y = dot(c_SunDir.xyz, binorm);
fsundir.z = dot(c_SunDir.xyz, b_objnorm);
fsundir.w = 0.3*exp(-0.002*b_camdir.w);
o.fsundir = fsundir;

o.v_blendtex = v_blendtex;


float4 fproj;
fproj.x = dot(b_objpos, c_WVP._11_21_31_41);
fproj.y = dot(b_objpos, c_WVP._12_22_32_42);
fproj.z = 0;
fproj.w = dot(b_objpos, c_WVP._14_24_34_44);
fproj.xy = float2(0.5, -0.5) * fproj.xy + 0.5 * fproj.ww; // tex coords

o.fproj = fproj;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 fcamdir = i.fcamdir;
float4 fsundir = i.fsundir;
float2 v_blendtex = i.v_blendtex;
float4 fproj = i.fproj;
o.color0 = 0;
float3 fdif = 0;
o.color0.rgba = 0;

float4 blend = tex2D(c_tblend, v_blendtex);
half3 fnorm = 2 * blend.xyz - 1;
fnorm = lerp(half3(0,0,1), fnorm, fsundir.w);

fcamdir.xyz = normalize(fcamdir.xyz);
float fd = dot(fnorm.xyz, fcamdir.xyz);
half3 fcamrefl = 2 * fd * fnorm.xyz - fcamdir.xyz;

half3 col;
col.x = 1.2*pow(max(0,dot(normalize(fsundir.xyz), fcamrefl)), c_spec.a);
col.y = (1-fd)*(1-fd);
col.y = c_kr.x + c_kr.y * col.y * col.y * fd;
col.z = fcamdir.w;

fproj.xz += -fproj.w * fsundir.w * fnorm.xz;
float3 ice = tex2D(c_tex, 15*v_blendtex);

o.color0.rgba = 0.8*(1-col.y)*tex2Dproj(c_trefl, fproj);
o.color0.xyz += col.x * c_spec.xyz;
o.color0.rgba *= (1-blend.w);
//o.color0.rgba += blend.w;
o.color0.xyz += blend.w*ice +c_ice*col.yyy;// * ice;
o.color0.rgba *= col.z;
o.color0.w = 0;
return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

