float4x4 c_WVP;
shared float c_ElapsedTime;
float4 c_SunDir;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_texbump;
sampler2D c_texbump = sampler_state {
Texture = <t_c_texbump>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_spec;
texture t_c_texenv;
samplerCUBE c_texenv = sampler_state {
Texture = <t_c_texenv>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
};

float2 c_kr;
texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float3 c_snow;
float3 c_tint;
float3 c_center;
// mtrl type: bkIceRefl;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_tangent : TANGENT0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float3 b_objtangent:TEXCOORD0;
float3 binorm:TEXCOORD1;
float3 b_objnorm:TEXCOORD2;
float4 fcamdir:TEXCOORD3;
float fatten:TEXCOORD4;
float2 v_blendtex:TEXCOORD5;
float3 fenvoff:TEXCOORD6;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
half4 b_objtangent = i.v_tangent.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;

float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
b_objtangent.xyz += float3(1,0.5,-0.2) * sin(0.6*c_ElapsedTime);
b_objtangent = normalize(b_objtangent - b_objnorm * dot(b_objtangent.xyz, b_objnorm.xyz));
half3 binorm = cross(b_objnorm, b_objtangent);

// have to transform to world, but since level.. already in world
o.b_objtangent = b_objtangent;

o.binorm = binorm;

o.b_objnorm = b_objnorm;


half4 fcamdir = half4(b_camdir.xyz, min(b_objnorm.w+0.3,1));
o.fcamdir = fcamdir;


float fatten = exp(-0.01*b_camdir.w);
fatten = 1;
o.fatten = fatten;

o.v_blendtex = v_blendtex;


float3 fenvoff = float3(0.007, 0.02, 0.007) * (b_objpos + c_center);
o.fenvoff = fenvoff;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float3 b_objtangent = i.b_objtangent;
float3 binorm = i.binorm;
float3 b_objnorm = i.b_objnorm;
float4 fcamdir = i.fcamdir;
float fatten = i.fatten;
float2 v_blendtex = i.v_blendtex;
float3 fenvoff = i.fenvoff;
o.color0 = 0;
o.color1 = 0;
o.color0.rgba = 0;
half3 fnorm = 2 * tex2D(c_texbump  , 15*v_blendtex) - 1;
fnorm = b_objtangent * fnorm.x + binorm * fnorm.y + b_objnorm * fnorm.z;
fcamdir.xyz = normalize(fcamdir.xyz);
float fd = dot(fnorm.xyz, fcamdir.xyz);

half3 fcamrefl = 2 * fnorm.xyz * fd - fcamdir.xyz;

half3 col;
col.x = 1.5*pow(max(0,dot(c_SunDir, fcamrefl)), c_spec.a);
col.y = (1-fd)*(1-fd);
col.y = c_kr.x + c_kr.y * col.y * col.y;
col.z = fcamdir.w;

fd = max(0, dot(fnorm.xyz, c_SunDir));
float blend = min(tex2D(c_tblend, v_blendtex)+0.4,1);


float3 crefl = c_tint*(1-col.y)*texCUBE(c_texenv, fcamrefl+fenvoff);
float3 snow = tex2D(c_tex, 15*v_blendtex);

o.color0.xyz = lerp(crefl.xyz, c_snow.xyz, blend);
o.color0.xyz += col.x* c_spec.xyz;
//o.color0.rgba *= (1-blend);
//o.color0.rgba += blend;
o.color0.rgba *= col.z;
o.color0.w = col.y;
o.color1.rgb = 0;//16*float3(0.05,0.005,0.001);
return o;
}

technique tech0
{
	pass P0
	{
//SrcBlend = One;
//DestBlend = SrcAlpha;
//AlphaBlendEnable = True;
VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

