float4x4 c_WVP;
shared float c_ElapsedTime;
float4 c_SunDir;
texture t_c_tcaust;
sampler2D c_tcaust = sampler_state {
Texture = <t_c_tcaust>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_spec;
float2 c_kr;
texture t_c_trefl;
sampler2D c_trefl = sampler_state {
Texture = <t_c_trefl>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_blue;
texture t_c_tshore;
sampler2D c_tshore = sampler_state {
Texture = <t_c_tshore>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

// mtrl type: bkOcean;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_tangent : TANGENT0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 fcamdir:TEXCOORD0;
float4 fsundir:TEXCOORD1;
float2 fcaust1:TEXCOORD2;
float2 fcaust2:TEXCOORD3;
float2 v_blendtex:TEXCOORD4;
float4 fproj:TEXCOORD5;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
half4 b_objtangent = i.v_tangent.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;

float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
float3 binorm = cross(b_objnorm.xyz, b_objtangent.xyz);

float4 fcamdir;
fcamdir.x = dot(b_camdir.xyz, b_objtangent);
fcamdir.y = dot(b_camdir.xyz, binorm);
fcamdir.z = dot(b_camdir.xyz, b_objnorm);
fcamdir.w = b_objnorm.w;
o.fcamdir = fcamdir;


half4 fsundir;
fsundir.x = dot(c_SunDir.xyz, b_objtangent);
fsundir.y = dot(c_SunDir.xyz, binorm);
fsundir.z = dot(c_SunDir.xyz, b_objnorm);
fsundir.w = 0.5*exp(-0.002*b_camdir.w);
o.fsundir = fsundir;

//float2 fcaust = v_blendtex.xy * float2(2,32);
//fcaust.x += floor(2*c_ElapsedTime)/16;
float f = frac(0.005*c_ElapsedTime);
float2 fcaust1 = 4 * (v_blendtex.xy + f);
float2 fcaust2 = 10 * (v_blendtex.yx - f);


o.fcaust1 = fcaust1;

o.fcaust2 = fcaust2;

o.v_blendtex = v_blendtex;


float4 fproj;
fproj.x = dot(b_objpos, c_WVP._11_21_31_41);
fproj.y = dot(b_objpos, c_WVP._12_22_32_42);
fproj.z = 0;
fproj.w = dot(b_objpos, c_WVP._14_24_34_44);
fproj.xy = float2(0.5, -0.5) * fproj.xy + 0.5 * fproj.ww; // tex coords

o.fproj = fproj;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 fcamdir = i.fcamdir;
float4 fsundir = i.fsundir;
float2 fcaust1 = i.fcaust1;
float2 fcaust2 = i.fcaust2;
float2 v_blendtex = i.v_blendtex;
float4 fproj = i.fproj;
o.color0 = 0;
o.color0.rgba = 0;
float4 shore = tex2D(c_tshore, v_blendtex);
//half3 fnorm = 2 * tex2D(c_tcaust, fcaust) - 1;
float3 fnorm = normalize(0.7*tex2D(c_tcaust, fcaust1).xyz + 1.3*tex2D(c_tcaust, fcaust2).xyz - 1 + shore.w);

//fcamdir.xyz = normalize(fcamdir.xyz);
float fd = dot(fnorm.xyz, fcamdir.xyz);
half3 fcamrefl = 2 * fd * fnorm.xyz - fcamdir.xyz;

half3 col;
//col.x =5* pow(max(0,dot(normalize(fsundir.xyz), fcamrefl)+0.1), c_spec.a);
col.x =1.0*pow(max(0,dot(normalize(fcamdir.xyz+fsundir.xyz), fnorm)+0.1), c_spec.a);
//col.x += 0.2*max(0,dot(normalize(fsundir.xyz), fnorm));
col.y = (1-fd)*(1-fd);
col.y = c_kr.x + c_kr.y * col.y * col.y * fd;
col.z = fcamdir.w;

fproj.xz += -fproj.w * fsundir.w * fnorm.xz;


o.color0.rgba = lerp(c_blue, tex2Dproj(c_trefl, fproj), col.y);
o.color0.xyz += col.x * c_spec.xyz;
o.color0.xyz = lerp(o.color0.xyz, shore.xyz, shore.w);
o.color0.w = 0;
return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

