float4x4 c_WVP;
shared float c_ElapsedTime;
float4 c_SunDir;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float2 c_kr;
float4 c_spec;
texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_tbump;
sampler2D c_tbump = sampler_state {
Texture = <t_c_tbump>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_tcaust;
sampler2D c_tcaust = sampler_state {
Texture = <t_c_tcaust>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

// mtrl type: bkRiver;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_tangent : TANGENT0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 fcamdir:TEXCOORD0;
float3 fsundir:TEXCOORD1;
float2 v_blendtex:TEXCOORD2;
float2 fcoords:TEXCOORD3;
float2 fcaust:TEXCOORD4;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
half4 b_objtangent = i.v_tangent.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;

float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
half3 binorm = cross(b_objnorm, b_objtangent);


half4 fcamdir;
fcamdir.x = dot(b_camdir.xyz, b_objtangent);
fcamdir.y = dot(b_camdir.xyz, binorm);
fcamdir.z = dot(b_camdir.xyz, b_objnorm);
fcamdir.w = min(b_objnorm.w+0.2,1);
//fcamdir.xyz = 0.5 * fcamdir.xyz + 0.5;
o.fcamdir = fcamdir;
 //, COLOR, 0);

half3 fsundir;
fsundir.x = dot(c_SunDir.xyz, b_objtangent);
fsundir.y = dot(c_SunDir.xyz, binorm);
fsundir.z = dot(c_SunDir.xyz, b_objnorm);
o.fsundir = fsundir;

float2 fcoords = 10*(v_blendtex - 0.4*frac(0.01*c_ElapsedTime));
float2 fcaust = v_blendtex.xy * float2(4,64);
fcaust.x += floor(20*c_ElapsedTime)/16;

o.v_blendtex = v_blendtex;

o.fcoords = fcoords;

o.fcaust = fcaust;

o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 fcamdir = i.fcamdir;
float3 fsundir = i.fsundir;
float2 v_blendtex = i.v_blendtex;
float2 fcoords = i.fcoords;
float2 fcaust = i.fcaust;
o.color0 = 0;
o.color1 = 0;

half3 b_objnorm = 2 * tex2D(c_tcaust, fcaust) - 1;

fcamdir.xyz = normalize(fcamdir.xyz);
//fcamdir.xyz = 2 * fcamdir.xyz -1;
//fsundir.xyz = normalize(fsundir.xyz);
float fd = dot(b_objnorm.xyz, fcamdir.xyz);

half3 fcamrefl = 2 * b_objnorm.xyz * fd - fcamdir.xyz;

half4 col;
col.x = pow(max(0, 0.2+0.7*dot(fsundir, fcamrefl)), c_spec.a);
col.z = fcamdir.w;
col.y= (1-fd)*(1-fd);
col.y = c_kr.x + c_kr.y * col.y * col.y;
o.color0.rgba = 0;
//float4 blend = tex2D(c_tblend, v_blendtex);
o.color0.xyz = 0.7*tex2D(c_tex, fcoords);
o.color0.xyz += c_spec.xyz*(1.5*col.xxx+col.yyy);
//o.color0.rgba *= (1-blend.w)+0.4;
o.color0.w = (1-col.y);//+blend.w;//blend+0.4;
o.color1.rgb = 0;
return o;
}

technique tech0
{
	pass P0
	{
AlphaBlendEnable = True;
SrcBlend = One;
DestBlend = SrcAlpha;
VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

