float4x4 c_WVP;
float3 c_CameraPos;
float4 c_SunDir;
float4 c_SunColor;
texture t_c_tsnow;
sampler2D c_tsnow = sampler_state {
Texture = <t_c_tsnow>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Mirror;
AddressV = Mirror;
};

float2 c_veltex;
float4 c_spec;
float2 c_kr;
texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_ttrans;
sampler2D c_ttrans = sampler_state {
Texture = <t_c_ttrans>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float3 c_snow;
float3 c_snow2;
texture t_c_trock;
sampler2D c_trock = sampler_state {
Texture = <t_c_trock>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

// mtrl type: bkSnow;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_tangent : TANGENT0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 col:COLOR0;
float3 finfo:TEXCOORD0;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
half4 b_objtangent = i.v_tangent.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
float3 h = 0.5 + 0.5 * normalize(b_camdir.xyz +c_SunDir.xyz);

float3 finfo, v;
finfo.xy = v_blendtex.xy;

v = c_CameraPos - b_objpos;
finfo.z = min(0.00004 * dot(v, v), 1);
float4 col;
col.xy = lit(0.5*dot(c_SunDir, b_objnorm.xyz)+0.5, dot(b_objnorm.xyz, h.xyz), c_spec.a).yz;
col.z = min(1, b_objnorm.w+0.4);
col.w = max (0, 0.005*b_objpos.x-0.85); // used for transition purposes

o.col = col;

o.finfo = finfo;



o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 col = i.col;
float3 finfo = i.finfo;
o.color0 = 0;
o.color1 = 0;
float blend = tex2D(c_tblend, finfo.xy).x;

float3 fspec = col.w*c_spec.xyz*col.yyy;

float3 ttrans = tex2D(c_ttrans, 20*finfo.xy);
float3 trans = ttrans.y * c_snow + (1.4*ttrans.x+0.5*finfo.z) * c_snow2;

// add in distance based snow
float3 snow = c_snow2*(finfo.z + (1-finfo.z)*tex2D(c_tsnow, 50*finfo.xy));
float3 rock = tex2D(c_trock, 40*finfo);

float3 curcol = lerp(trans, snow, col.w);
o.color0.xyz = lerp(curcol, rock, blend);
o.color0.xyz *= col.x * c_SunColor.xyz;
o.color0.xyz += fspec;
o.color0.xyz *= col.z;
o.color0.w =  0;
o.color1.rgb = 0;


return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

