float4x4 c_WVP;
shared float c_ElapsedTime;
float4 c_SunDir;
float2 c_kr;
texture t_c_tgrass;
sampler2D c_tgrass = sampler_state {
Texture = <t_c_tgrass>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_spec;
texture t_c_trock2;
sampler2D c_trock2 = sampler_state {
Texture = <t_c_trock2>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

// mtrl type: bkTopMntn;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
half4 v_tangent : TANGENT0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 b_objnorm:COLOR0;
float2 v_blendtex:TEXCOORD0;
float3 fcoords:TEXCOORD1;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
half4 b_objtangent = i.v_tangent.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
b_objnorm.xyz = 0.5 + 0.5 * b_objnorm.xyz;

o.b_objnorm = b_objnorm;


float3 fcoords;
fcoords.xy = v_blendtex * 80;
fcoords.z = sin(c_ElapsedTime*0.5)*0.5+2;
o.v_blendtex = v_blendtex;

o.fcoords = fcoords;



o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 b_objnorm = i.b_objnorm;
float2 v_blendtex = i.v_blendtex;
float3 fcoords = i.fcoords;
o.color0 = 0;
o.color1 = 0;
o.color0.rgba = 0;

b_objnorm.xyz = normalize(2*b_objnorm.xyz-1);
float fdif = 1.3*max(dot(b_objnorm, c_SunDir), 0);

float3 cgrass = 0.4*tex2D(c_tgrass,fcoords);
float2 blend = tex2D(c_tblend, v_blendtex).xz;
blend.xy *= float2(1,1.3);
blend.x = min(1, blend.x + blend.y);
//float3 crocks = blend.y * tex2D(c _trock,  0.05*fcoords.xy) + 
//                     (1-blend.x)*1.2*(1-blend.y) * tex2D(c_trock2, 0.2*fcoords.xy);
float3 crocks = fcoords.z* tex2D(c_trock2, 0.1*fcoords.xy);

o.color0.xyz = blend.x * cgrass.xyz + (1-blend.x) * crocks;
o.color0.xyz *= fdif;
//o.color0.xyz += (1-blend.x)*c_spec.xyz*suncolor.yyy;
o.color0.rgba *= blend.y+b_objnorm.w+0.1;
o.color0.w = 0;
o.color1.rgb = 0;


return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

