float4x4 c_WVP;
shared float c_ElapsedTime;
float3 c_CameraPos;
float4 c_SunDir;
float4 c_SunColor;
texture t_c_tgrass;
sampler2D c_tgrass = sampler_state {
Texture = <t_c_tgrass>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float2 c_veltex;
float4 c_spec;
float2 c_kr;
texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_tnoise;
sampler2D c_tnoise = sampler_state {
Texture = <t_c_tnoise>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_tbase;
sampler2D c_tbase = sampler_state {
Texture = <t_c_tbase>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float3 c_snow;
float3 c_snow2;
// mtrl type: bkTransSnow;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 b_objnorm:COLOR0;
float2 v_blendtex:TEXCOORD0;
float2 fnewtex:TEXCOORD1;
float4 h:COLOR1;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
float2 vel = c_veltex * sin(c_ElapsedTime * 0.3f);
float2 fnewtex = 300.0f*v_blendtex.yx + vel ;

float4 h;
h.xyz = 0.5 + 0.5 * normalize(b_camdir.xyz +c_SunDir.xyz);
float3 v = c_CameraPos - b_objpos;
h.w = min(0.0001 * dot(v, v), 0.6);

b_objnorm.xyz = 0.5 + 0.5 * b_objnorm.xyz;
o.b_objnorm = b_objnorm;

o.v_blendtex = v_blendtex;

o.fnewtex = fnewtex;

o.h = h;



o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 b_objnorm = i.b_objnorm;
float2 v_blendtex = i.v_blendtex;
float2 fnewtex = i.fnewtex;
float4 h = i.h;
o.color0 = 0;
o.color1 = 0;
float noise = tex2D(c_tnoise, fnewtex*0.1);

b_objnorm.xyz = normalize(2 * b_objnorm.xyz - 1);
h.xyz = normalize(2*h.xyz-1);
float2 col = lit(dot(c_SunDir, b_objnorm.xyz)+0.25, dot(b_objnorm.xyz, h.xyz), c_spec.a).yz;
float blend = min(1, tex2D(c_tblend, v_blendtex).x+0.2);

float3 grass = 0.5f * (noise*tex2D(c_tgrass, fnewtex) + tex2D(c_tgrass, 200*v_blendtex));
float3 fspec = blend*c_spec.xyz*col.yyy;

float3 tbase = tex2D(c_tbase, 35*v_blendtex);
float3 base = tbase.y * c_snow + (1.3*tbase.x+h.w) * c_snow2;

blend *= min(2*tbase.z+0.5,1);
o.color0.xyz = lerp(base.xyz, grass.xyz, blend);
o.color0.xyz *= col.x * c_SunColor.xyz;
o.color0.xyz += fspec;
o.color0.xyz *= b_objnorm.www;
o.color0.w =  0;
o.color1.rgb = 0;


return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

