float4x4 c_WVP;
float4 c_SunDir;
texture t_c_tex;
sampler2D c_tex = sampler_state {
Texture = <t_c_tex>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float2 c_kr;
texture t_c_tgrass;
sampler2D c_tgrass = sampler_state {
Texture = <t_c_tgrass>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

texture t_c_tblend;
sampler2D c_tblend = sampler_state {
Texture = <t_c_tblend>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

float4 c_spec;
float4 c_Blue;
texture t_c_trock2;
sampler2D c_trock2 = sampler_state {
Texture = <t_c_trock2>;
MipFilter = LINEAR;
MinFilter = LINEAR;
MagFilter = LINEAR;
AddressU = Wrap;
AddressV = Wrap;
};

// mtrl type: bkWaterbed;
struct VSINPUT {
float4 v_pos : POSITION0;
half4 v_normal : NORMAL0;
float2 v_blendtex : TEXCOORD0;
};

struct PSOUTPUT {
	half4 color0 : COLOR0;
	half4 color1 : COLOR1;

};

float3 c_CameraPos;
struct PASS0_PSINPUT
{
float4 v_pos : POSITION0;
float4 b_objnorm:COLOR0;
float2 v_blendtex:TEXCOORD0;
float2 fcoords:TEXCOORD1;
};

PASS0_PSINPUT Pass0VS(VSINPUT i)
{
PASS0_PSINPUT o;
float4 b_objpos = i.v_pos;
half4 cnorm__125 = half4(2,1,-1,0);
half4 b_objnorm = i.v_normal.zyxw * cnorm__125.xxxy + cnorm__125.zzzw;
float2 v_blendtex = i.v_blendtex;
float4 b_camdir;
float fmytemp12;
b_camdir.xyz = c_CameraPos.xyz - b_objpos.xyz;
b_camdir.w = dot(b_camdir.xyz, b_camdir.xyz);
fmytemp12 = rsqrt(b_camdir.w);
b_camdir.xyzw *= fmytemp12;
float4 vals;

//float3 h = 0.5 + 0.5 * normalize(b_camdir.xyz +c_SunDir.xyz);
b_objnorm.xyz = 0.5 + 0.5 * b_objnorm.xyz;

o.b_objnorm = b_objnorm;


float2 fcoords = v_blendtex * 100;
o.v_blendtex = v_blendtex;

o.fcoords = fcoords;



o.v_pos = mul(b_objpos, c_WVP);
return o;
}

PSOUTPUT Pass0PS(PASS0_PSINPUT i)
{
PSOUTPUT o;
float4 b_objnorm = i.b_objnorm;
float2 v_blendtex = i.v_blendtex;
float2 fcoords = i.fcoords;
o.color0 = 0;
o.color1 = 0;
o.color0.rgba = 0;

b_objnorm.xyz = normalize(2*b_objnorm.xyz-1);
float fdif = max(dot(b_objnorm, c_SunDir), 0);

float3 cgrass = tex2D(c_tgrass,fcoords);
float2 blend = min(1,tex2D(c_tblend, v_blendtex).xz+0.2);
blend.x += 0.2;
float3 crocks = tex2D(c_trock2,  0.2*fcoords);

o.color0.xyz = blend.x * cgrass.xyz + (1-blend.x) * crocks;
o.color0.xyz *= fdif;
//o.color0.xyz += (1-blend.x)*c_spec.xyz*suncolor.yyy;
o.color0.rgba *= b_objnorm.w+0.1;
o.color0.w = 0;
o.color1.rgb = 0;


return o;
}

technique tech0
{
	pass P0
	{

VertexShader = compile vs_2_0 Pass0VS();
PixelShader = compile ps_2_0 Pass0PS();
	}
}

