// post process effect scales the bloom texture to 256x256
texture g_txSrc < int rt = 1; >;

sampler2D g_samSrc = sampler_state {
    Texture = <g_txSrc>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

static const int SAMPLES = 4;

// need to uniformly sample a 4x3 rect
float2 PixelKernel[SAMPLES] = {
	0.5, 0.3333,
	2.5, 0.3333,
	0.5, 1.6666,
	2.5, 1.6666 };
	
float2 TexelKernel[SAMPLES] < string OrgPixels = "PixelKernel"; >;

float4 Scale256(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
    float4 sample = 0.0f;

	for( int i=0; i < SAMPLES; i++ ) {
		sample += tex2D( g_samSrc, vScreenPosition + TexelKernel[i] );
	}
    
	return sample * 0.25;
}

technique tech0 < int postrt = 10;
				int width = 256;
				int height = 256;
				> {
	pass p0 {
		PixelShader = compile ps_2_0 Scale256();
	}
}
